
// START SNIPPET: Content
/* all the includes *except* cecilia.h */
#include <stdio.h>

/** Component internal data, empty here. */
DECLARE_DATA {
} ;

/* Include cecilia.h. Must be included after the DECLARE_DATA */
#include <cecilia.h>
/* Include used interface definitions */
#include <Itf.idl.h>

// -----------------------------------------------------------------------------
// Implementation of the 'main' boot interface.
// -----------------------------------------------------------------------------

// int main(int argc, string[] argv)
int METHOD(r, main) (void *_this, int argc, char *argv[]){
    juint i;
    jint val;
    jint result;
    fractal_api_Component mycomponent;
    Itf itf;

    printf("Entering main\n");
    for (i = 0; i < ATTRIBUTES.numberOfComponents; i++) {
        result = CALL(REQUIRED.factory, createMyComponentInstance, (void *)&mycomponent);
        if (result != MyComponentFactory_CREATE_OBJECT_OK) {
            fprintf(stderr,"Couldn't create object !\n");
        }
        else {
            // Retrieve and call 1st interface of object.
            result = CALL(mycomponent, getFcInterface, "i1", (void *)&itf);
            if (result != fractal_api_ErrorConst_OK && result != fractal_api_ErrorConst_NO_SUCH_INTERFACE) {
                fprintf(stderr, "ERR: getFcInterface returned a strange return value !\n");
            }
            if (result == fractal_api_ErrorConst_OK) {
                val = CALL(itf, getMyComponentNumber);

                printf("\t%d\t",val);
            }
            else {
                fprintf(stderr, "ERR: no interface 'i1' on Object !\n");
            }

            // Call the workload.
            CALL(itf, eatCPU);

            // Retrieve and call 2nd interface of object.
            result = CALL(mycomponent, getFcInterface, "i2", (void *)&itf);
            if (result != fractal_api_ErrorConst_OK && result != fractal_api_ErrorConst_NO_SUCH_INTERFACE) {
                fprintf(stderr, "ERR: getFcInterface returned a strange return value !\n");
            }
            if (result == fractal_api_ErrorConst_OK) {
                val = CALL(itf, getMyComponentNumber);

                printf("%d\t",val);
            }
            else {
                fprintf(stderr, "ERR: no interface 'i2' on Object !\n");
            }

            // Call the workload.
            CALL(itf, eatCPU);

            // Retrieve and call 3rd interface of object.
            result = CALL(mycomponent, getFcInterface, "i3", (void *)&itf);
            if (result != fractal_api_ErrorConst_OK && result != fractal_api_ErrorConst_NO_SUCH_INTERFACE) {
                fprintf(stderr, "ERR: getFcInterface returned a strange return value !\n");
            }
            if (result == fractal_api_ErrorConst_OK) {
                val = CALL(itf, getMyComponentNumber);

                printf("%d\t",val);

                // Call the workload.
                CALL(itf, eatCPU);
            }
            else {
                fprintf(stderr, "ERR: no interface 'i3' on Object !\n");
            }

            // Flush stdout by printing a newline.
            printf("\n");

            // Don't forget to destroy our objects :-)
            CALL(REQUIRED.factory, destroyMyComponentInstance, mycomponent);
        }
    }
    printf("Exiting main\n");

    return 0;
}
